#include "fontlist.h"
#include <windows.h>

struct FontList {
	HANDLE hFind;
	BOOL first;
	char path[MAX_PATH];
};

#ifdef USE_SHGETSPECIALFOLDERPATH

#include <shlobj.h>
BOOL 
get_fontpath( char *path )
{
	BOOL res = SHGetSpecialFolderPath( 0, path, CSIDL_FONTS, FALSE );

	if ( res == FALSE )
		return FALSE;

	strcat( path, "\\" );
	return TRUE;
}

#else

BOOL
get_fontpath( char *path )
{
	BOOL res = GetWindowsDirectoryA( path, MAX_PATH ); /* strlen("\\fonts") = 6 */

	if ( res == FALSE )
		return FALSE;

	strcat( path, "\\fonts\\" );
	return TRUE;
}

#endif // USE_SHGET


FontList *
fontlist_open(void)
{
	FontList *fl = malloc( sizeof(*fl) );
	fl->first = TRUE;
	fl->hFind = INVALID_HANDLE_VALUE;

	return fl;
}

void
fontlist_close( FontList *fl )
{
	if ( fl->hFind != INVALID_HANDLE_VALUE )
		FindClose(fl->hFind);
	free( fl );
}

char *
fontlist_next_file( FontList *fl )
{
	WIN32_FIND_DATA fd;

	get_fontpath( fl->path );

	if ( fl->first ) {

		int len = strlen( fl->path );

		strcat( fl->path, "*.tt*" );
		fl->hFind = FindFirstFile( fl->path, &fd );
		if ( fl->hFind == INVALID_HANDLE_VALUE )
			return NULL;

		fl->path[len] = '\0';

		fl->first = FALSE;
	} else {
		if ( FindNextFile( fl->hFind, &fd )==0 )
			return NULL;
	}

	strcat( fl->path, fd.cFileName );

	return fl->path;
}

